unit BMI_Rechner;

{$mode objfpc}{$H+}

interface

uses
  Classes,SysUtils,FileUtil,Forms,Controls,Graphics,Dialogs,StdCtrls,
  Menus,Funktionen,Chk_Eingabe,LCLTranslator,LocalizedForms;

type

  { TForm1 }

  TForm1 = class(TLocalizedForm)
    EdGroesse: TEdit;
    EdGew: TEdit;
    EdBMI: TEdit;
    LblBMIErg: TLabel;
    LblBMI: TLabel;
    LblGewkg: TLabel;
    LblGew: TLabel;
    LblGrcm: TLabel;
    LblGroesse: TLabel;
    MainMenu1: TMainMenu;
    MenItClose: TMenuItem;
    MenItLang: TMenuItem;
    MenIt_DE: TMenuItem;
    MenIt_EN: TMenuItem;
    procedure EdGewEditingDone(Sender: TObject);
    procedure MenIt_DEClick(Sender: TObject);
    procedure MenIt_ENClick(Sender: TObject);
  private
    { private declarations }
    FGroesse: Double;
    FGewicht: Double;
    FBMI: Double;
  protected
    procedure PrepareTranslation; override;
    procedure SelectLanguage(ALang: String);
    procedure UpdateTranslation(ALang: String); override;
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.PrepareTranslation;
// Wird vor der Sprachumschaltung aufgerufen
begin
  if EdGroesse.Text <> '' then
    FGroesse := StrToFloat(EdGroesse.Text);
  if EdGew.Text <> '' then
    FGewicht := StrToFloat(EdGew.Text);
  if EdBMI.Text <> '' then
    FBMI := StrToFloat(EdBMI.Text);

  inherited;
  // Das ruft PrepareLanguage auch für alle anderen Formulare auf
  // Kann hier im Prinzip entfallen, weil du nur ein Formular hast.
end;

procedure TForm1.UpdateTranslation(ALang: String);
// Wird nach der Sprachumschaltung aufgerufen
begin
  if EdGroesse.Text <> '' then
    EdGroesse.Text := FloatToStr(FGroesse);
  if EdGew.Text <> '' then
    EdGew.Text := FloatToStr(FGewicht);
  if EdBMI.Text <> '' then
    EdBMI.Text := FloatToStr(FBMI);

  inherited;
  // Inherited ruft wieder "UpdateTranslation" für alle anderen Formulare auf
end;

procedure TForm1.EdGewEditingDone(Sender: TObject);
begin
  EdBMI.SetFocus;
  EdBMI.Text:=FloatToStr(BMI_berechnen(StrToFloat(EdGroesse.Text),StrToFloat(EdGew.Text)));
end;

procedure TForm1.MenIt_DEClick(Sender: TObject);
begin
  SelectLanguage('de');
end;

procedure TForm1.MenIt_ENClick(Sender: TObject);
begin
  SelectLanguage('en');
end;

// Führt die Sprachumschaltung durch, und alles was damit zusammenhängt
procedure TForm1.SelectLanguage(ALang: String);
begin
  // Edit controls auslesen
  PrepareTranslation;

  // Sprache umschalten
  SetDefaultLang(ALang);

  // FormatSettings umschalten
  UpdateFormatSettings(ALang);

  // BiDiMode anpassen (hier egal, wichtig für hebräische etc.)
  UpdateBiDiMode(ALang);

  // Spezielle Übersetzungsprozedur der Fenster aufrufen
  UpdateTranslation(ALang);

  // Neue Sprache im Men+ markieren
  MenIt_EN.Checked := ALang = 'en';
  MenIt_DE.Checked := ALang = 'de';
end;

end.

