unit Chk_Eingabe;
// Prüfung der Eingaben

{$mode objfpc}{$H+}

interface

uses
  Classes,SysUtils,LCLType,Dialogs,LCLIntf;

  function Nur_Zahl(var key: char):char;
  function Entferne_Char(var key: char):char;
  function Entferne_UTF8(var UTF8Key: TUTF8Char):TUTF8Char;
  function Entferne_Zahl(var key: char):char;
  function Entferne_Leerzeichen(s: string):string;
  function Entferne_Tabs(s: string):string;
  function Korrigiere_Namen(s: string; const CapitalizeFirst: Boolean = True):string;

  const CR = #13#10;        // Carriage-Return
  const BS = #8;            // BackSpace
  const TAB = #9;           // Tabulator
  const leerzeichen = #32;  // Leerzeichen
  const FF = #12;           // FormFeed

implementation

function Nur_Zahl(var key: char):char;
// es werden nur Zahlen und die BackSpace-Taste akzeptiert
begin
  if not (key in ['0'..'9',bs]) then key:=#0;
  Nur_Zahl:=key;
end;

function Entferne_Char(var key: char):char;
// Buchstaben und die meisten Satzzeichen werden entfernt
begin
  if not (key in ['0'..'9',',','.','-',BS]) then key:=#0;
  //wegen eines BUGS unterschiedliche Kommata in Windows und Linux
  {$ifdef WINDOWS}
  if (key='.') then key:=',';
  {$endif WINDOWS}
  {$ifdef LINUX}
  if (key=',') then key:='.';
  {$endif LINUX}
  Entferne_Char:=key;
end;

function Entferne_UTF8(var UTF8Key: TUTF8Char):TUTF8Char;
// UTF8-Zeichen und einige Sonderzeichen werden entfernt
// Alternativ kann bei der 'OnUTF8KeyPress'-Funktion auch
// UTF8Key:='' gesetzt werden
begin
//Deutsche Umlaute müssen mittels UTF8Key (unit 'LCLType')abgefragt werden
  if (UTF8Key='ö') or (UTF8Key='Ö') or (UTF8Key='ä') or (UTF8Key='Ä') or
    (UTF8Key='ü') or (UTF8Key='Ü') or (UTF8Key='ß') or (UTF8Key='#') or
    (UTF8Key='+') then UTF8Key:='';
  Entferne_UTF8:=UTF8key;
end;

function Entferne_Zahl(var key: char):char;
// alle Zahlen werden entfernt
begin
  if key in ['0'..'9'] then key:=#0;
  Entferne_Zahl:=key;
end;

function Entferne_Leerzeichen(s: string): string;
// entfernt Leerzeichen
var
  i: integer;
begin
  for i:=length(s) downto 1 do
      if s[i]=#32 then delete(s,i,1);
  Entferne_Leerzeichen:=s;
end;

function Entferne_Tabs(s:string):string;
// Tab-Zeichen werden entfernt
var
  a, b, len: integer;
begin
  result:='';
  b:=0;
  a:=1;
  len:=Length(s);
  SetLength(result, Length(s));
  While a<len+1 do begin
    if (s[a]=TAB) and (a>1) and (s[a-1]<>TAB) then begin
      b:=b+1;
      result[b]:=s[a];
    end
    else if s[a]<>tab then begin
      b:=b+1;
      result[b]:=s[a];
    end;
    a:=a+1;
  end;
  SetLength(result, b);
end;

function Korrigiere_Namen(s: string; const CapitalizeFirst: Boolean = True):string;
// setzt die Anfangsbuchstaben groß
var
  s_tmp: string;
  i: integer;
  bCapitalizeNext: boolean;
begin
  bCapitalizeNext:=CapitalizeFirst;
  s_tmp:=LowerCase(s);
  if s_tmp<>EmptyStr then
    for i:=1 to Length(s_tmp) do
      if bCapitalizeNext then begin
        s_tmp[i]:=UpCase(s_tmp[i]);
        bCapitalizeNext:=False;
      end
      else
        if (s_tmp[i]='-') or (s_tmp[i]=#32) then bCapitalizeNext:=True;
  Korrigiere_Namen:=s_tmp;
end;

end.

